#ifdef _USE_WXWIDGETS_
#ifndef __bbCreaContournDimensions_h_INCLUDED__
#define __bbCreaContournDimensions_h_INCLUDED__
#include "bbtkWxBlackBox.h"

#include "wxContourMainFrame.h"

#include <map>
#include "vtkImageData.h"

#include "wx/artprov.h"
#include <wx/filedlg.h>

#include <vtkImageData.h>
#include <vtkMetaImageReader.h>

namespace bbcreaContours
{

class /*BBTK_EXPORT*/ nDimensions
 : 
   public bbtk::WxBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(nDimensions,bbtk::WxBlackBox);

//==================================================================
  BBTK_DECLARE_INPUT(WorkDir,std::string);
  BBTK_DECLARE_INPUT(In,vtkImageData*);
  BBTK_DECLARE_INPUT(ContourType,int);
  BBTK_PROCESS(Process);
  void Process();
  BBTK_CREATE_WIDGET(CreateWidget);
  void CreateWidget(wxWindow*);

  BBTK_DECLARE_OUTPUT(Mask,vtkImageData*);
  BBTK_DECLARE_OUTPUT(Value,vtkImageData*);
  BBTK_DECLARE_OUTPUT(X,double**);
  BBTK_DECLARE_OUTPUT(Y,double**);
  BBTK_DECLARE_OUTPUT(Z,double**);
  BBTK_DECLARE_OUTPUT(SizeContour,std::vector <int>);

private:
	//wxContourMainFrame* frame;
	vtkImageData* currentimg;
	//wxContourEventHandler * eventHandler;
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(nDimensions, bbtk::WxBlackBox);
BBTK_NAME("nDimensions");
BBTK_AUTHOR("car-prie@uniandes.edu.co");
BBTK_DESCRIPTION("With a given image, the box shows the nDimension application");
BBTK_CATEGORY("contours");
BBTK_INPUT(nDimensions,WorkDir,"Working data directory where config and data files are located",std::string,"");
BBTK_INPUT(nDimensions,In,"Image to be shown",vtkImageData*,"");
BBTK_INPUT(nDimensions,ContourType,"Contour type to be exported: ",int,"");

BBTK_OUTPUT(nDimensions, Mask, "Mask of the contours",vtkImageData*,"");
BBTK_OUTPUT(nDimensions, Value, "Value of the contours",vtkImageData*,"");
BBTK_OUTPUT(nDimensions, X, "Array of arrays that contains the X coordinates of each contour", double**, "");
BBTK_OUTPUT(nDimensions, Y, "Array of arrays that contains the Y coordinates of each contour", double**, "");
BBTK_OUTPUT(nDimensions, Z, "Array of arrays that contains the Z coordinates of each contour", double**, "");
BBTK_OUTPUT(nDimensions, SizeContour, "Vector that contains the coordinates of each contour", std::vector <int>, "");

BBTK_END_DESCRIBE_BLACK_BOX(nDimensions);
}
// EO namespace bbCreaContour

#endif // __bbCreaContournDimensions_h_INCLUDED__
#endif // _USE_WXWIDGETS_
