#include "interfDeleteMenu.h"

interfDeleteMenu::interfDeleteMenu(wxWindow * parent, int sizex, int sizey,wxEvtHandler* evtHandler, std::string datdir)
	: interfMenuBar(parent, sizex, sizey)
{
	this->datadir = datdir;
	initButtons(this);
}

void interfDeleteMenu::initButtons(wxEvtHandler* evtHandler) {

	std::vector<std::string> path, nom;
	std::vector<wxObjectEventFunction> funct;

	path.push_back(datadir + "/DeleteContour.png");
	nom.push_back("Delete the selected contour");
	funct.push_back((wxObjectEventFunction)&interfDeleteMenu::onDeleteContour);

	path.push_back(datadir + "/DeleteAllContourSlide.png");
	nom.push_back("Delete all contours in the current slide");
	funct.push_back((wxObjectEventFunction)&interfDeleteMenu::onDeleteContoursActSlice);

	path.push_back(datadir + "/DeleteAll.png");
	nom.push_back("Delete all contours in all slides");
	funct.push_back((wxObjectEventFunction)&interfDeleteMenu::onDeleteAllContours);

    this->addButtons(path, nom);

	this->setVectorFunction(funct);	
	this->connectEvents(evtHandler);

}

interfDeleteMenu::~interfDeleteMenu()
{
}


void interfDeleteMenu::onDeleteContour(wxCommandEvent& event){
	interfMainPanel::getInstance()->onDeleteContour();
}
void interfDeleteMenu::onDeleteContoursActSlice(wxCommandEvent& event){
	interfMainPanel::getInstance()->onDeleteContoursActSlice();
}
void interfDeleteMenu::onDeleteAllContours(wxCommandEvent& event){
	interfMainPanel::getInstance()->onDeleteAllContours();
}

