#ifndef __interfSegmentationMenuH__
#define __interfSegmentationMenuH__

#include <wx/wx.h>


#include "interfMenuBar.h"

class interfSegmentationMenu 
	: public interfMenuBar
{
public:
	interfSegmentationMenu(wxWindow * parent, int sizex, int sizey,wxEvtHandler* evtHandler, std::string datdir = "data/Icons");		
	~interfSegmentationMenu();

    virtual void initButtons(wxEvtHandler* evtHandler) ;

	/**
	**	Responds to the events of the buttons, when the same panel is responsible for it. It gets the name
	**	of the button corresponding to the method that has to be executed,
	**	it uses attribute eventHandler to call the methods define by the application.
	**	see setEventHandler(wxEventHandler*)
	**/
	
	void  onSegmentationPressed(wxCommandEvent& event);

	void  onSegmentationPressedITK(wxCommandEvent& event);

	void  onSnakePressed(wxCommandEvent& event);

	void onMirrorPressed(wxCommandEvent& event);

	void onThreshold(wxCommandEvent& event);

private:

	//wxContourEventHandler* contourevent;
	wxPanel* configPanel;
	wxWindow* infoWin;
	
	wxPanel* spreadPanel;
	wxPanel* segmentPanelITK;
	bool axisshown;

	wxPanel* getSegmentationPanel(wxWindow* parent);

	void onSegmentationOneSlice( wxCommandEvent& event );

	void onSegmentationAllSlice( wxCommandEvent& event );

	
	
};

#endif
 
 
