#ifndef __interfToolsMenuH__
#define __interfToolsMenuH__

#include <wx/wx.h>
#include <wx/utils.h>


#include "interfMenuBar.h"

class interfToolsMenu 
	: public interfMenuBar
{
public:
	interfToolsMenu(wxWindow * parent, int sizex, int sizey,wxEvtHandler* evtHandler, std::string datdir = "data/Icons");		
	~interfToolsMenu();

    virtual void initButtons(wxEvtHandler* evtHandler) ;

	/**
	**	Responds to the events of the buttons, when the same panel is responsible for it. It gets the name
	**	of the button corresponding to the method that has to be executed,
	**	it uses attribute eventHandler to call the methods define by the application.
	**	see setEventHandler(wxEventHandler*)
	**/
	void onRigidPressed(wxCommandEvent& event);

	void  onSpreadPressed(wxCommandEvent& event);

	void  onInformationPressed(wxCommandEvent& event);

	void  onConfigurationPressed(wxCommandEvent& event);

	void onHelpPressed(wxCommandEvent& event);

private:

	//wxContourEventHandler* contourevent;
	wxPanel* configPanel;
	wxPanel* segmentPanel;
	wxPanel* spreadPanel;
	wxPanel* segmentPanelITK;
	bool axisshown;

	
	
};

#endif
 
 
