#ifndef __interfToolsSpreadPanelH__
#define __interfToolsSpreadPanelH__

#include <wx/wx.h>
#include <wx/radiobox.h>
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/scrolwin.h>
#include <wx/list.h>


#include "interfMenuBar.h"

class interfToolsSpreadPanel 
	: public wxPanel
{
public:
	interfToolsSpreadPanel(wxWindow * parent, int sizex, int sizey,wxEvtHandler* evtHandler);		
	~interfToolsSpreadPanel();

	/**
	**	Adds a new checkbox to the scrolledwindow using the checkboxsizer
	**	@Params id of contour
	**	
	**/
	void addContourCheckBox(std::string id);

	/**
	**	Removes a checkbox from the list of checkboxes in the flexsizer (checkboxsizer)
	**	@Params id of contour
	**	
	**/
	void removeContourCheckBox(std::string id);

private:
	wxPanel* resetbuttxt;
	wxPanel* gobuttxt;
	wxPanel* radiobox;
	wxPanel* addremovecont;
//Atributes for managing the events of adding and removing the checkbox
	wxScrolledWindow* scrollwin;
	wxFlexGridSizer* checkboxsizer;
	std::vector<std::string> checkvect;
	


	/**
	**	initializes the radio box to display the options of the spread method.
	**/
	wxPanel* initializeRadioBox();

	/**
	**	initializes the button and the text to be displayed
	**	it returns a panel with both components
	**	@param Path of the image to be used in the button
	**	@param nom	text to be displayed at right of the button
	**/
	wxPanel* initializeButton(std::string path, std::string nom);

	/**
	**	initializes the panel that has all the contours that exist in the interface
	**	every time a contour is added into the scene, it must be added into this panel
	**	for all the contours it must exist a check box beside the contour.
	**	This checkbox controls the contours that are going to be used in the spread function.
	**/

	wxPanel* initializeAddRemoveContour();

	


};

#endif

