
//----------------------------------------------------------------------------------------------------------------
// Class definition include
//----------------------------------------------------------------------------------------------------------------
#include "ConceptDataWrap.h"

//----------------------------------------------------------------------------------------------------------------
// Class implementation
//----------------------------------------------------------------------------------------------------------------
/** @file ConceptDataWrap.cxx */


//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------


	//------------------------------------------------------------------------------------------------------------
	// Constructors & Destructors
	//------------------------------------------------------------------------------------------------------------

ConceptDataWrap :: ConceptDataWrap(std::string theName)
	{
		_minValue = -1;
		_maxValue = -1;
		_minShow = -1;
		_maxShow = -1;
		_actual = -1;
		_name = theName;
	}

	ConceptDataWrap :: ~ConceptDataWrap()
	{

	}
	//------------------------------------------------------------------------------------------------------------
	//  Attributes getters and setters
	//------------------------------------------------------------------------------------------------------------

	/**
	* Sets the data concept values and name
	* @param theName The name of the concept 
	* @param minRepresent The minRepresent value of the concept 
	* @param maxRepresent The maxRepresent value of the concept 
	* @param minShowed The minShowed value of the concept 
	* @param maxShowed The maxShowed value of the concept 
	* @param actualShow The actualShow value of the concept 
	*/
	void ConceptDataWrap :: fillData( std::string theName, int minRepresent, int maxRepresent, int minShowed, int maxShowed, int actualShow )
	{
		_name = theName;
		_minValue = minRepresent;
		_maxValue = maxRepresent;
		_minShow = minShowed;
		_maxShow = maxShowed;
		_actual = actualShow;
	}


	std::string ConceptDataWrap :: getName()
	{
		return _name;
	}

	int ConceptDataWrap :: getMinShowedValue()
	{
		return _minShow;
	}

	int ConceptDataWrap :: getMaxShowedValue()
	{
		return _maxShow;
	}

	void ConceptDataWrap :: setMinValue(int theMin)
	{
		_minValue = theMin;
	}

	int  ConceptDataWrap :: getMinValue()
	{
		return _minValue;
	}

	void ConceptDataWrap :: setMaxValue(int theMax)
	{
		_maxValue = theMax;
	}

	int  ConceptDataWrap :: getMaxValue()
	{
		return _maxValue;
	}

	void ConceptDataWrap :: setActualValue(int theActual)
	{
		_actual = theActual;
	}

	int  ConceptDataWrap :: getActualValue()
	{
		return _actual;
	}

	bool ConceptDataWrap :: isEmpty()
	{
		return _actual == -1;
	}
	//------------------------------------------------------------------------------------------------------------
	//  Other functional methods
	//------------------------------------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------
	//  Private methods
	//------------------------------------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------
	// Creational and initialization methods
	//------------------------------------------------------------------------------------------------------------

		
	//------------------------------------------------------------------------------------------------------------
	// Attributtes
	//------------------------------------------------------------------------------------------------------------
	

