#ifndef __KEY_THING__
#define __KEY_THING__


//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------
#include <iostream>
#include <string>

class KeyThing{

	
//------------------------------------------------------------------------------------------------------------
// Constructors & Destructors
//------------------------------------------------------------------------------------------------------------
public:

	/*
	* Creates the key thing	
	* @param thePrefix Is the prefix of the new keyThing for the key generation correponding to the new keyThing
	* @param theValue Is the value of the intial key generation correponding to the new keyThing
	*/
	KeyThing(std::string thePrefix, int theValue);

	/*
	* Destroys the key thing	
	*/
	~KeyThing();

	
//------------------------------------------------------------------------------------------------------------
// Public Methods
//------------------------------------------------------------------------------------------------------------

	/*
	* Sets the prefix of the keyThing
	*/
	void setPrefix( std::string aPrefix);
	
	/*
	* Sets the value value of the keyThing
	* @param aValue The valueimum to set
	*/
	void setValue (int aValue);

	/*
	* Gets the prefix of the keyThing
	* @return prefix The setted prefix
	*/
	std::string getPrefix();
	
	/*
	* Gets the value value of the keyThing
	* @return value The setted valueimum
	*/
	int getValue();

//------------------------------------------------------------------------------------------------------------
// Constants
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
// Attributes
//------------------------------------------------------------------------------------------------------------
	
private: 	

	/*
	* Represents the prefix of the keyThing
	*/
	std::string prefix;
	
	/*
	* Represents the value value of the keyThing
	*/
	int value;
};
#endif

